package lbi.jdbc.sample;

import lbi.utils.*;
import java.io.*;
import java.sql.*;
import java.util.*;

public class SQL {
    public static void main(String[] args) {
        try {
// load proprierties
            Properties props = IOUtil.readProps("myJDBCdef.props");
// load drivers
            
            DBUtil.loadJDBC(props.getProperty("jdbcDriver"));
            BufferedReader stdin = IOUtil.getReader("");
            String url = props.getProperty("jdbcURL");
            String user = props.getProperty("userName");
            String pwd = props.getProperty("userPWD");
            Connection con = DriverManager.getConnection(url, user, pwd);
            Statement stmt = con.createStatement();
            while (true) {
                System.out.print("> ");
                String querySQL = stdin.readLine();
                if (querySQL.equals("exit")) {
                    con.close();
                    break;
                }
                Cronos c = new Cronos();
                c.start();
                try {
                    ResultSet rs = stmt.executeQuery(querySQL);
                    DBUtil.toCSV(rs);
                } catch (SQLException e) {
                    System.out.println(e.toString());
                }
                c.stop();
                double elps = c.elapsed();
                System.out.println("Elapsed time: " + elps + " secs.");
            }
        } catch (Exception e) {
            System.out.println(e.toString());
            System.exit(0);
        }

    }
}

