package lbi.jdbc.sample;

import lbi.utils.*;

import java.util.*;
import java.time.Duration;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.io.*;
import java.sql.*;

public class Sample3 {

    public static void main(String[] args) throws SQLException, IOException,
            ClassNotFoundException {
// load proprierties
        Properties props = IOUtil.readProps("myJDBCdef.props");
// load drivers
        DBUtil.loadJDBC(props.getProperty("jdbcDriver"));
// connect to data source, using userName and userPWD
        String url = props.getProperty("jdbcURL");
        String user = props.getProperty("userName");
        String pwd = props.getProperty("userPWD");
        Connection con = DriverManager.getConnection(url, user, pwd);
        Statement stmt = con.createStatement();
        ResultSet rs = stmt.executeQuery(
                "SELECT ord_date, count(*) AS counts FROM sales " +
                "GROUP BY ord_date " +
                "ORDER BY ord_date");

        if( rs.next() ) { // there is at least one row
            DateTimeFormatter dform = DateTimeFormatter.ofPattern("dd/MMM/yyyy hh:mm:ss.S");
            LocalDateTime firstDate = rs.getTimestamp("ord_date").toLocalDateTime(); // new in Java 8
            int count = rs.getInt("counts");
            System.out.println("First order on: " + dform.format(firstDate) +
                    " was " + count + " pieces ");
            while (rs.next()) {
            	LocalDateTime lastDate = rs.getTimestamp("ord_date").toLocalDateTime();
                count = rs.getInt("counts");
                Duration diff = Duration.between(firstDate, lastDate);
                System.out.println(
                        " then after " + diff.toDays()
                        + " days " + count + " pieces ");
                firstDate = lastDate;
            }
        }
        con.close();
    }
}
