package lbi.jdbc.sample;

import lbi.utils.*;
import java.io.*;
import java.sql.*;
import java.util.*;

public class Sample4 {

    public static void toCSV(ResultSet rs, PrintWriter os) throws SQLException {
        ResultSetMetaData md = rs.getMetaData();
// number of columns
        int nCols = md.getColumnCount();
// output result set
        while (rs.next()) {
            for (int i = 1; i < nCols; ++i)
                os.print(rs.getString(i) + ",");
            os.println(rs.getString(nCols));
        }
// flush printwriter
        os.flush();
    }

    public static void toCSVmd(ResultSet rs, PrintWriter os) throws
            SQLException {
        ResultSetMetaData md = rs.getMetaData();
// output column names
        int nCols = md.getColumnCount();
        for (int i = 1; i < nCols; ++i)
            os.print(md.getColumnName(i) + ",");
        os.println(md.getColumnName(nCols));
// output result set
        while (rs.next()) {
            for (int i = 1; i < nCols; ++i)
                os.print(rs.getString(i) + ",");
            os.println(rs.getString(nCols));
        }
// flush printwriter
        os.flush();
    }


    public static void main(String[] args) throws SQLException, IOException {
// load proprierties
        Properties props = IOUtil.readProps("myJDBCdef.props");
// load drivers
        DBUtil.loadJDBC(props.getProperty("jdbcDriver"));
// connect to data source, using userName and userPWD
        String url = props.getProperty("jdbcURL");
        String user = props.getProperty("userName");
        String pwd = props.getProperty("userPWD");
        Connection con = DriverManager.getConnection(url, user, pwd);
        Statement stmt = con.createStatement();
// retrieve sql query from properties
        String sqlQuery = props.getProperty("sqlQuery");
        ResultSet rs = stmt.executeQuery(sqlQuery);
        PrintWriter output = IOUtil.getWriter("");
        toCSVmd(rs, output);
        output.close();
        con.close();
    }
}

