package lbi.jdbc.sample;

import lbi.utils.*;
import java.sql.*;
import java.util.*;
import java.io.*;

public class Sample6 {
    public static void main(String[] args) throws SQLException, IOException {
// load proprierties
        Properties props = IOUtil.readProps("myJDBCdef.props");
// load drivers
        DBUtil.loadJDBC(props.getProperty("jdbcDriver"));

// connect to destination
        String url = props.getProperty("jdbcURLDest");
        String user = props.getProperty("userNameDest");
        String pwd = props.getProperty("userPWDDest");
        Connection conDest = DriverManager.getConnection(url, user, pwd);
        DatabaseMetaData dbmd = conDest.getMetaData();
        String catalog = null;
        String schema = null;
        String table = "sales_copy";
        String[] types = null;
        ResultSet rs = dbmd.getTables(catalog, schema, table, types);
        if (!rs.next()) {
// if table does not exists, create it
            Statement stmt = conDest.createStatement();
            String createTable = "CREATE TABLE " + table +
                                 " (ord_num text, " +
                                 " ord_date datetime, " +
                                 " qty  real)";
            System.out.println(createTable);
            stmt.executeUpdate(createTable);
            stmt.close();
        }

// connect to source
        url = props.getProperty("jdbcURLSource");
        user = props.getProperty("userNameSource");
        pwd = props.getProperty("userPWDSource");
        Connection conSource = DriverManager.getConnection(url, user, pwd);
        Statement stmtSource = conSource.createStatement();
// select input data
        String sqlQuery = "SELECT ord_num, ord_date, qty " +
                          " FROM sales";
        System.out.println(sqlQuery);
        rs = stmtSource.executeQuery(sqlQuery);

// parametric insert
        String sqlDest = "INSERT INTO " + table + " VALUES (?, ?, ?)";
        System.out.println(sqlDest);
        PreparedStatement stmtDest = conDest.prepareStatement(sqlDest);
        int countRead = 0;

// copy input data
        while (rs.next()) {
            stmtDest.setString(1, rs.getString(1));
            stmtDest.setDate(2, rs.getDate(2));
            stmtDest.setDouble(3, rs.getDouble(3));
            stmtDest.executeUpdate();
            ++countRead;
        }
        System.out.println("Read rows: " + countRead);
        conDest.close();
        conSource.close();
    }
}
