package lbi.jdbc.sample;

import lbi.utils.*;
import java.sql.*;
import java.util.*;
import java.io.*;

public class Sample7 {
    public static void main(String[] args) throws SQLException, IOException {
// load proprierties
        Properties props = IOUtil.readProps("myJDBCdef.props");
// load drivers
        DBUtil.loadJDBC(props.getProperty("jdbcDriver"));
// connect to source

        String url = props.getProperty("jdbcURLSource");
        String user = props.getProperty("userNameSource");
        String pwd = props.getProperty("userPWDSource");
        Connection conSource = DriverManager.getConnection(url, user, pwd);
        Statement stmtS = conSource.createStatement();
        ResultSet rs = stmtS.executeQuery(
                "SELECT * FROM " + props.getProperty("tableSource"));

        ResultSetMetaData md = rs.getMetaData();
        int nCols = md.getColumnCount();
        String sql = "INSERT INTO " + props.getProperty("tableDest") +
                     "(";
        for (int i = 1; i < nCols; ++i) {
            sql += md.getColumnName(i) + ",";
        }
        sql += md.getColumnName(nCols) + ") ";
        sql += "VALUES (";
        for (int i = 1; i < nCols; ++i) {
        	sql += "?,";
        }
        sql += "?)";

        System.out.println(sql);

// connect to destination
        url = props.getProperty("jdbcURLDest");
        user = props.getProperty("userNameDest");
        pwd = props.getProperty("userPWDDest");
        Connection conDest = DriverManager.getConnection(url, user, pwd);
        PreparedStatement stmtD = conDest.prepareStatement(sql);

        int countRead = 0;
        while (rs.next()) {
            for (int i = 1; i <= nCols; ++i)
                stmtD.setObject(i, rs.getObject(i));
            stmtD.executeUpdate();
            ++countRead;
        }
        System.out.println("Read rows: " + countRead);

        conDest.close();
        conSource.close();
    }
}
